<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_67) on Tue Oct 14 13:30:14 CEST 2014 -->
<title>CPMTask</title>
<meta name="date" content="2014-10-14">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="CPMTask";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/CPMTask.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../fr/inria/alpage/cpm/task/CPMCommand.html" title="class in fr.inria.alpage.cpm.task"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?fr/inria/alpage/cpm/task/CPMTask.html" target="_top">Frames</a></li>
<li><a href="CPMTask.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_classes_inherited_from_class_java.lang.Thread">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">fr.inria.alpage.cpm.task</div>
<h2 title="Class CPMTask" class="title">Class CPMTask</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>java.lang.Thread</li>
<li>
<ul class="inheritance">
<li>fr.inria.alpage.cpm.task.CPMTask</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.lang.Runnable</dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">CPMTask</span>
extends java.lang.Thread</pre>
<div class="block">This class defines a list of subprocess <code>TaskUnit</code></div>
<dl><dt><span class="strong">Author:</span></dt>
  <dd>buiquang</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="nested_classes_inherited_from_class_java.lang.Thread">
<!--   -->
</a>
<h3>Nested classes/interfaces inherited from class&nbsp;java.lang.Thread</h3>
<code>java.lang.Thread.State, java.lang.Thread.UncaughtExceptionHandler</code></li>
</ul>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#id">id</a></strong></code>
<div class="block">The id of the task</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#name">name</a></strong></code>
<div class="block">The name of the task</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.util.ArrayList&lt;<a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task">CPMTaskUnit</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#processes">processes</a></strong></code>
<div class="block">the list of processes defined in this task</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>com.mongodb.BasicDBObject</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#taskObject">taskObject</a></strong></code>
<div class="block">The json db object reprenting this task</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_java.lang.Thread">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;java.lang.Thread</h3>
<code>MAX_PRIORITY, MIN_PRIORITY, NORM_PRIORITY</code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#CPMTask()">CPMTask</a></strong>()</code>
<div class="block">Constructor : create a new task</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#CPMTask(java.lang.String)">CPMTask</a></strong>(java.lang.String&nbsp;id)</code>
<div class="block">Constructor : retrieve a task from an id</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#addTaskUnit(fr.inria.alpage.cpm.task.CPMTaskUnit)">addTaskUnit</a></strong>(<a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task">CPMTaskUnit</a>&nbsp;tu)</code>
<div class="block">add a task unit to the list of processes defined in this task</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#getInfo(java.lang.String)">getInfo</a></strong>(java.lang.String&nbsp;data)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#isRunning()">isRunning</a></strong>()</code>
<div class="block">checks in db if the task is currently running</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static <a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html" title="class in fr.inria.alpage.cpm.task">CPMTask</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#parseData(com.mongodb.BasicDBObject)">parseData</a></strong>(com.mongodb.BasicDBObject&nbsp;taskObject)</code>
<div class="block">Create or update a task with a json object definition/representation of a task</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html" title="class in fr.inria.alpage.cpm.task">CPMTask</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#parseData(java.lang.String)">parseData</a></strong>(java.lang.String&nbsp;data)</code>
<div class="block">Create or update a task with a serialized json object definition/representation of a task</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#run()">run</a></strong>()</code>
<div class="block">run the task.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#save()">save</a></strong>()</code>
<div class="block">Save modification to the task in db</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html#setRunningStatus(boolean)">setRunningStatus</a></strong>(boolean&nbsp;running)</code>
<div class="block">set the running status of the task in db</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Thread">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Thread</h3>
<code>activeCount, checkAccess, clone, countStackFrames, currentThread, destroy, dumpStack, enumerate, getAllStackTraces, getContextClassLoader, getDefaultUncaughtExceptionHandler, getId, getName, getPriority, getStackTrace, getState, getThreadGroup, getUncaughtExceptionHandler, holdsLock, interrupt, interrupted, isAlive, isDaemon, isInterrupted, join, join, join, resume, setContextClassLoader, setDaemon, setDefaultUncaughtExceptionHandler, setName, setPriority, setUncaughtExceptionHandler, sleep, sleep, start, stop, stop, suspend, toString, yield</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="processes">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>processes</h4>
<pre>public&nbsp;java.util.ArrayList&lt;<a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task">CPMTaskUnit</a>&gt; processes</pre>
<div class="block">the list of processes defined in this task</div>
</li>
</ul>
<a name="id">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>id</h4>
<pre>public&nbsp;java.lang.String id</pre>
<div class="block">The id of the task</div>
</li>
</ul>
<a name="name">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>name</h4>
<pre>public&nbsp;java.lang.String name</pre>
<div class="block">The name of the task</div>
</li>
</ul>
<a name="taskObject">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>taskObject</h4>
<pre>public&nbsp;com.mongodb.BasicDBObject taskObject</pre>
<div class="block">The json db object reprenting this task</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="CPMTask()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>CPMTask</h4>
<pre>public&nbsp;CPMTask()</pre>
<div class="block">Constructor : create a new task</div>
</li>
</ul>
<a name="CPMTask(java.lang.String)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>CPMTask</h4>
<pre>public&nbsp;CPMTask(java.lang.String&nbsp;id)</pre>
<div class="block">Constructor : retrieve a task from an id</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>id</code> - </dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="addTaskUnit(fr.inria.alpage.cpm.task.CPMTaskUnit)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addTaskUnit</h4>
<pre>public&nbsp;void&nbsp;addTaskUnit(<a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task">CPMTaskUnit</a>&nbsp;tu)</pre>
<div class="block">add a task unit to the list of processes defined in this task</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>tu</code> - the TaskUnit defining the new process to append to the task</dd></dl>
</li>
</ul>
<a name="save()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>save</h4>
<pre>private&nbsp;void&nbsp;save()</pre>
<div class="block">Save modification to the task in db</div>
</li>
</ul>
<a name="run()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>run</h4>
<pre>public&nbsp;void&nbsp;run()</pre>
<div class="block">run the task. check if not already running. skip finished task.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>run</code>&nbsp;in interface&nbsp;<code>java.lang.Runnable</code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code>run</code>&nbsp;in class&nbsp;<code>java.lang.Thread</code></dd>
</dl>
</li>
</ul>
<a name="getInfo(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInfo</h4>
<pre>public static&nbsp;java.lang.String&nbsp;getInfo(java.lang.String&nbsp;data)</pre>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>data</code> - a json serialized representation of task defining information, namely :
 - id : the id of the task,
 - task : the index of the taskunit (optional)
 - action : the kind of information wanted ("status"[default], "info", "fullinfo", "output" and "stderr")</dd>
<dt><span class="strong">Returns:</span></dt><dd>a json serialized representation of information about the task :
 - info : returns the db representation of the task
 - fullinfo : returns the name, the outputs and status a taskunit
 - status : returns the status a taskunit
 - output : return the output of a taskunit
 - stderr : return the stderr of a taskunit</dd></dl>
</li>
</ul>
<a name="parseData(com.mongodb.BasicDBObject)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parseData</h4>
<pre>public static&nbsp;<a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html" title="class in fr.inria.alpage.cpm.task">CPMTask</a>&nbsp;parseData(com.mongodb.BasicDBObject&nbsp;taskObject)</pre>
<div class="block">Create or update a task with a json object definition/representation of a task</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>taskObject</code> - the json db representation of a task</dd>
<dt><span class="strong">Returns:</span></dt><dd>the task as defined by the taskObject argument</dd></dl>
</li>
</ul>
<a name="parseData(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parseData</h4>
<pre>public static&nbsp;<a href="../../../../../fr/inria/alpage/cpm/task/CPMTask.html" title="class in fr.inria.alpage.cpm.task">CPMTask</a>&nbsp;parseData(java.lang.String&nbsp;data)</pre>
<div class="block">Create or update a task with a serialized json object definition/representation of a task</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>taskObject</code> - the serialized json db representation of a task</dd>
<dt><span class="strong">Returns:</span></dt><dd>the task as defined by the data argument</dd></dl>
</li>
</ul>
<a name="isRunning()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isRunning</h4>
<pre>public&nbsp;boolean&nbsp;isRunning()</pre>
<div class="block">checks in db if the task is currently running</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>true if the task is running, else false</dd></dl>
</li>
</ul>
<a name="setRunningStatus(boolean)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setRunningStatus</h4>
<pre>public&nbsp;void&nbsp;setRunningStatus(boolean&nbsp;running)</pre>
<div class="block">set the running status of the task in db</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>running</code> - the running status value (true or false)</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/CPMTask.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../fr/inria/alpage/cpm/task/CPMCommand.html" title="class in fr.inria.alpage.cpm.task"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../fr/inria/alpage/cpm/task/CPMTaskUnit.html" title="class in fr.inria.alpage.cpm.task"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?fr/inria/alpage/cpm/task/CPMTask.html" target="_top">Frames</a></li>
<li><a href="CPMTask.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_classes_inherited_from_class_java.lang.Thread">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
